## function2 4.2.5

=== cmake/CMakeLists.txt ===
include(cmake/configure_compiler.cmake)

=== test/CMakeLists.txt ===
add_library(gtest STATIC
  "${CMAKE_CURRENT_LIST_DIR}/googletest/googletest/src/gtest-all.cc"
  "${CMAKE_CURRENT_LIST_DIR}/googletest/googletest/src/gtest_main.cc")

target_include_directories(gtest
  PRIVATE
    "${CMAKE_CURRENT_LIST_DIR}/googletest/googletest"
  PUBLIC
    "${CMAKE_CURRENT_LIST_DIR}/googletest/googletest/include")

target_compile_definitions(gtest
  PUBLIC
    -DGTEST_HAS_PTHREAD=0
    -DGTEST_LANG_CXX11=1)

target_compile_features(gtest
  PUBLIC
    cxx_alias_templates
    cxx_auto_type
    cxx_decltype
    cxx_final
    cxx_lambdas
    cxx_nullptr
    cxx_override)

add_executable(function2_tests
  ${CMAKE_CURRENT_LIST_DIR}/../include/function2/function2.hpp
  ${CMAKE_CURRENT_LIST_DIR}/assign-and-constructible-test.cpp
  ${CMAKE_CURRENT_LIST_DIR}/build-test.cpp
  ${CMAKE_CURRENT_LIST_DIR}/empty-function-call-test.cpp
  ${CMAKE_CURRENT_LIST_DIR}/function2-test.hpp
  ${CMAKE_CURRENT_LIST_DIR}/functionality-test.cpp
  ${CMAKE_CURRENT_LIST_DIR}/noexcept-test.cpp
  ${CMAKE_CURRENT_LIST_DIR}/self-containing-test.cpp
  ${CMAKE_CURRENT_LIST_DIR}/standard-compliant-test.cpp
  ${CMAKE_CURRENT_LIST_DIR}/type-test.cpp
  ${CMAKE_CURRENT_LIST_DIR}/multi-signature-test.cpp
  ${CMAKE_CURRENT_LIST_DIR}/regressions.cpp
  ${CMAKE_CURRENT_LIST_DIR}/view-test.cpp
  ${CMAKE_CURRENT_LIST_DIR}/overload-test.cpp)

target_link_libraries(function2_tests
  PRIVATE
    function2
    gtest)

add_test(NAME function2-unit-tests COMMAND function2_tests)

add_executable(function2_playground
  ${CMAKE_CURRENT_LIST_DIR}/../include/function2/function2.hpp
  ${CMAKE_CURRENT_LIST_DIR}/playground.cpp)

target_link_libraries(function2_playground
  PRIVATE
    function2)

=== test/dist-package/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)
project(function2containtest VERSION 2.2.0 LANGUAGES CXX)

find_package(function2 2)

add_executable(function2-dist-package main.cpp)

target_link_libraries(function2-dist-package function2::function2)

=== test/dist-subproject/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)
project(function2containtest VERSION 2.2.0 LANGUAGES CXX)

add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/../..)

add_executable(function2-dist-subproject main.cpp)

target_link_libraries(function2-dist-subproject function2::function2)

=== debian/changelog ===
function2 (4.2.5-0~mx25) mx; urgency=medium

  * Initial build for MX-25

 -- Timothy E. Harris <maintainer@mxrepo.com>  Sun, 21 Dec 2025 00:13:23 +0000

=== debian/control ===
Source: function2
Section: Libraries
Priority: optional
Maintainer: Timothy E. Harris <maintainer@mxrepo.com>
Build-Depends:  debhelper (>= 12),
				cmake,
				googletest,
				libgtest-dev,
				clang
Standards-Version: 4.5.8

Package: function2-dev
Architecture: any
Description: function2 provides improved implementations of std::function:

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh ${@}

override_dh_configure:
	mv googletest test/googletest
	cmake .. -DCMAKE_BUILD_TYPE="Release" \
           -DCMAKE_INSTALL_PREFIX=/usr \
           -DBUILD_TESTING=OFF
           
override_dh_strip:
	dh_strip --no-automatic-dbgsym
